import * as React from 'react';
import { StyledComponent, StyledComponentProps, StrictValue } from './types';
export declare function styled<TComponent extends keyof JSX.IntrinsicElements | React.ComponentType<any>, TConfigs extends (string | {
    [key: string]: unknown;
})[]>(Component: TComponent, ...configs: {
    [K in keyof TConfigs]: string extends TConfigs[K] ? TConfigs[K] : {
        variants?: {
            [Name in string]: {
                [Pair in number | string]: string;
            };
        };
        defaultVariants?: 'variants' extends keyof TConfigs[K] ? {
            [Name in keyof TConfigs[K]['variants']]?: StrictValue<keyof TConfigs[K]['variants'][Name]>;
        } : Record<string, never>;
        compoundVariants?: 'variants' extends keyof TConfigs[K] ? Array<{
            [Name in keyof TConfigs[K]['variants']]?: StrictValue<keyof TConfigs[K]['variants'][Name]>;
        } & {
            className: string;
        }> : [];
        forwardProps?: 'variants' extends keyof TConfigs[K] ? (keyof TConfigs[K]['variants'])[] : [];
    } | string;
}): StyledComponent<TComponent, StyledComponentProps<TConfigs>> & React.RefAttributes<TComponent>;
