var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { styled } from './styled';
import { render, waitFor } from '@testing-library/react';
import userEvent from '@testing-library/user-event';
describe('styled', function () {
    var TestComponent = function (props) {
        return (React.createElement("div", { className: props.className }, props.open ? 'open' : 'closed'));
    };
    it('adds boolean true variant prop', function () {
        var StyledComponent = styled(TestComponent, {
            variants: {
                test: {
                    true: 'open',
                },
            },
        });
        render(React.createElement(StyledComponent, { test: true }));
    });
    it('adds className via configuration', function () {
        var className = 'some-class';
        var StyledComponent = styled(TestComponent, className);
        var container = render(React.createElement(StyledComponent, null)).container;
        expect(container.firstChild).toHaveClass(className);
    });
    it('adds className via configuration + prop', function () {
        var className = 'some-class';
        var otherClassName = 'other-class';
        var StyledComponent = styled(TestComponent, className);
        var container = render(React.createElement(StyledComponent, { className: otherClassName })).container;
        expect(container.firstChild).toHaveClass(className);
        expect(container.firstChild).toHaveClass(otherClassName);
    });
    it('merges wrapped component props with variant props', function () {
        var class1 = 'class1';
        var StyledComponent = styled(TestComponent, {
            variants: {
                test: {
                    true: class1,
                },
            },
        });
        var container = render(React.createElement(StyledComponent, { test: true, open: true })).container;
        expect(container.firstChild).toHaveClass(class1);
    });
    it('merges multiple variant configs', function () {
        var class1 = 'class1';
        var class2 = 'class2';
        var StyledComponent = styled(TestComponent, {
            variants: {
                prop1: {
                    value1: class1,
                },
            },
            defaultVariants: {
                prop1: 'value1',
            },
            forwardProps: ['prop1'],
        }, {
            variants: {
                prop2: {
                    value2: class2,
                },
            },
        });
        var container = render(React.createElement(StyledComponent, { prop1: 'value1', prop2: 'value2' })).container;
        expect(container.firstChild).toHaveClass(class1);
        expect(container.firstChild).toHaveClass(class2);
    });
    it('merges variant config + class config + prop', function () {
        var class1 = 'class1';
        var class2 = 'class2';
        var class3 = 'class3';
        var StyledComponent = styled(TestComponent, class1, {
            variants: {
                prop1: {
                    value1: class2,
                },
            },
        });
        var container = render(React.createElement(StyledComponent, { className: class3, prop1: 'value1' })).container;
        expect(container.firstChild).toHaveClass(class1);
        expect(container.firstChild).toHaveClass(class2);
        expect(container.firstChild).toHaveClass(class3);
    });
    it('creates component from itrinsic HTML element key', function () {
        var elementNames = [
            'div',
            'span',
            'h1',
            'h2',
            'h3',
            'h4',
            'h5',
            'h6',
            'p',
            'a',
            'ul',
            'ol',
            'li',
            'table',
            'form',
            'fieldset',
            'legend',
            'label',
            'input',
            'button',
            'select',
            'option',
            'textarea',
            'article',
            'aside',
            'header',
            'footer',
            'nav',
            'section',
            'main',
            'dialog',
            'summary',
            'details',
            'menu',
        ];
        elementNames.forEach(function (elementName) {
            var class1 = 'class1';
            var StyledComponent = styled(elementName, {
                variants: {
                    active: {
                        true: class1,
                    },
                },
            });
            var container = render(React.createElement(StyledComponent, { active: true })).container;
            expect(container.firstChild).toHaveClass(class1);
        });
    });
    it('passes through builtin component props', function () { return __awaiter(void 0, void 0, void 0, function () {
        var class1, CONTENT_TEXT, StyledComponent, handleClick, getByText, label;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    class1 = 'class1';
                    CONTENT_TEXT = 'LABEL';
                    StyledComponent = styled('div', {
                        variants: {
                            active: {
                                true: class1,
                            },
                        },
                    });
                    handleClick = jest.fn();
                    getByText = render(React.createElement(StyledComponent, { onClick: handleClick, active: true }, CONTENT_TEXT)).getByText;
                    label = getByText(CONTENT_TEXT);
                    expect(label).toHaveClass(class1);
                    userEvent.click(label);
                    return [4 /*yield*/, waitFor(function () {
                            expect(handleClick).toHaveBeenCalled();
                        })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    it('does not forward variant props', function () {
        var classOpen = 'open';
        var classClosed = 'closed';
        var StyledComponent = styled(TestComponent, {
            variants: {
                open: {
                    true: classOpen,
                    false: classClosed,
                },
            },
        });
        var getByText = render(React.createElement(StyledComponent, { open: true })).getByText;
        var component = getByText('closed');
        expect(component).toHaveClass(classOpen);
    });
    it('does forward variant props configured via forwardProps', function () {
        var classOpen = 'open';
        var classClosed = 'closed';
        var StyledComponent = styled(TestComponent, {
            variants: {
                open: {
                    true: classOpen,
                    false: classClosed,
                },
            },
            forwardProps: ['open'],
        });
        var getByText = render(React.createElement(StyledComponent, { open: true })).getByText;
        var component = getByText('open');
        expect(component).toHaveClass(classOpen);
    });
    it('sets classes via defaultVariants', function () {
        var classOpen = 'open';
        var classClosed = 'closed';
        var StyledComponent = styled(TestComponent, {
            variants: {
                open: {
                    true: classOpen,
                    false: classClosed,
                },
            },
            defaultVariants: {
                open: true,
            },
        });
        var getByText = render(React.createElement(StyledComponent, null)).getByText;
        var component = getByText('closed');
        expect(component).toHaveClass(classOpen);
    });
    it('handles forwardRef props for intrinsic HTML elements', function () {
        var PLACEHOLDER_TEXT = 'some placeholder';
        var class1 = 'class1';
        var SearchInput = React.forwardRef(function (props, ref) {
            var className = props.className, rest = __rest(props, ["className"]);
            return (React.createElement("input", __assign({}, rest, { className: className, ref: ref, type: "search", placeholder: PLACEHOLDER_TEXT })));
        });
        var StyledComponent = styled(SearchInput, {
            variants: {
                active: {
                    true: class1,
                },
            },
        });
        var getByPlaceholderText = render(React.createElement(StyledComponent, { active: true })).getByPlaceholderText;
        var input = getByPlaceholderText(PLACEHOLDER_TEXT);
        expect(input).not.toHaveFocus();
        input.focus();
        expect(input).toHaveFocus();
        expect(input).toHaveClass(class1);
    });
    it('adds compount variant classes', function () {
        var class1 = 'class1';
        var class2 = 'class2';
        var class3 = 'class3';
        var StyledComponent = styled(TestComponent, {
            variants: {
                prop1: {
                    value1: class1,
                },
                prop2: {
                    value2: class2,
                },
            },
            compoundVariants: [
                {
                    prop1: 'value1',
                    prop2: 'value2',
                    className: class3,
                },
            ],
        });
        var container = render(React.createElement(StyledComponent, { prop1: 'value1', prop2: 'value2' })).container;
        expect(container.firstChild).toHaveClass(class1);
        expect(container.firstChild).toHaveClass(class2);
        expect(container.firstChild).toHaveClass(class3);
    });
    it('merges classes from multiple compount variant configurations', function () {
        var class1 = 'class1';
        var class2 = 'class2';
        var class3 = 'class3';
        var class4 = 'class4';
        var StyledComponent = styled(TestComponent, {
            variants: {
                prop1: {
                    value1: class1,
                },
                prop2: {
                    value2: class2,
                },
            },
            compoundVariants: [
                {
                    prop1: 'value1',
                    prop2: 'value2',
                    className: class3,
                },
                {
                    prop1: 'value1',
                    prop2: 'value2',
                    className: class4,
                },
            ],
        });
        var container = render(React.createElement(StyledComponent, { prop1: 'value1', prop2: 'value2' })).container;
        expect(container.firstChild).toHaveClass(class1);
        expect(container.firstChild).toHaveClass(class2);
        expect(container.firstChild).toHaveClass(class3);
        expect(container.firstChild).toHaveClass(class4);
    });
    it('does not add classes from unmatched compound variants', function () {
        var class1 = 'class1';
        var class2 = 'class2';
        var class3 = 'class3';
        var StyledComponent = styled(TestComponent, {
            variants: {
                prop1: {
                    value1: class1,
                    value2: class1,
                },
                prop2: {
                    value2: class2,
                },
            },
            compoundVariants: [
                {
                    prop1: 'value1',
                    prop2: 'value2',
                    className: class3,
                },
            ],
        });
        var container = render(React.createElement(StyledComponent, { prop1: 'value2', prop2: 'value2' })).container;
        expect(container.firstChild).toHaveClass(class1);
        expect(container.firstChild).toHaveClass(class2);
        expect(container.firstChild).not.toHaveClass(class3);
    });
});
